/**
 * MIT License
 *
 * Copyright (c) 2022 Rezwan Ahmed Sami
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.routemamba = {}));
})(this, (function (exports) { 'use strict';

  exports.Info = void 0;
  (function (Info) {
      Info.website = 'https://www.routemamba.com';
      Info.documentation = "".concat(Info.website, "/documentation");
      Info.version = "v5.0.4";
      Info.build_date = "2024-07-24T11:22:43.146Z";
  })(exports.Info || (exports.Info = {}));
  /**
   * there all golbal array, object and variable initialized
   */
  var RouteComponentTypes;
  (function (RouteComponentTypes) {
      RouteComponentTypes[RouteComponentTypes["HEADER"] = 0] = "HEADER";
      RouteComponentTypes[RouteComponentTypes["META"] = 1] = "META";
      RouteComponentTypes[RouteComponentTypes["BODY"] = 2] = "BODY";
      RouteComponentTypes[RouteComponentTypes["FOOTER"] = 3] = "FOOTER";
      RouteComponentTypes[RouteComponentTypes["TAB"] = 4] = "TAB";
      RouteComponentTypes[RouteComponentTypes["ON_DEMAND_TABVIEW"] = 5] = "ON_DEMAND_TABVIEW";
  })(RouteComponentTypes || (RouteComponentTypes = {}));
  var HtmlSelector;
  (function (HtmlSelector) {
      HtmlSelector.Root = 'root';
      HtmlSelector.Header = 'header-root';
      HtmlSelector.Footer = 'footer-root';
      HtmlSelector.Body = 'body-root';
      HtmlSelector.OnDemandTabView = 'on-demand-tab-view';
  })(HtmlSelector || (HtmlSelector = {}));
  var RoutesStorage;
  (function (RoutesStorage) {
      RoutesStorage.RoutesPages = [];
      RoutesStorage.RoutesHeaders = [];
      RoutesStorage.RoutesFooters = [];
      RoutesStorage.server_host = '';
      RoutesStorage.meta_content_url = '';
      RoutesStorage.last_http_url = '';
      (function (RouteContentsState) {
          (function (renderStatus) {
              renderStatus.header = false;
              renderStatus.body = false;
              renderStatus.footer = false;
          })(RouteContentsState.renderStatus || (RouteContentsState.renderStatus = {}));
          RouteContentsState.ShouldHeaderload = true;
          RouteContentsState.ShouldFooterload = true;
          RouteContentsState.HeaderContent = null;
          RouteContentsState.FooterContent = null;
          RouteContentsState.BodyContent = null;
          RouteContentsState.MetaContent = null;
          RouteContentsState.HttpUrl = null;
      })(RoutesStorage.RouteContentsState || (RoutesStorage.RouteContentsState = {}));
  })(RoutesStorage || (RoutesStorage = {}));
  var OnDemandTabViewStorage;
  (function (OnDemandTabViewStorage) {
      (function (states) {
          states.RequestedTabViewid = null;
      })(OnDemandTabViewStorage.states || (OnDemandTabViewStorage.states = {}));
      OnDemandTabViewStorage.RegisteredOnDemandTabViews = [];
      OnDemandTabViewStorage.RegisterdTabViewsContents = [];
  })(OnDemandTabViewStorage || (OnDemandTabViewStorage = {}));
  var RenderConfig;
  (function (RenderConfig) {
      RenderConfig.await_rendering = true;
  })(RenderConfig || (RenderConfig = {}));
  /**
   * this is persist storage to store readonly value.
   */
  var PersistStorage;
  (function (PersistStorage) {
      PersistStorage.NetworkConfig = {
          localhost: 'http://localhost',
          localIp: 'http://127.0.0.1',
          localFilePath: 'file://',
          tauriHost: 'tauri://localhost',
          http_www: 'http://www.',
          https_www: 'https://www.',
      };
      PersistStorage.DomContent = {
          ErrorHeadContent: '<meta charset="UTF-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><title>ERROR</title>',
          DefineMetaUrlError: 'Define Meta Content Url',
          NavigateRoutePathUndefined: 'Naviagte method called but route path not defined.',
          __404_urlErrorContent: "\n        <style>\n        body{\n            margin: 0;\n            padding: 0;\n            background-color: rgb(245, 245, 245);\n         }\n         .error_body{\n            width: 100% !important;\n            height: 100% !important;\n            display: flex;\n            justify-content: center;\n            align-items: center;\n            margin-top: 20px;\n         }\n         \n         .error_card{\n            display: block;\n            width: 400px;\n            background-color: rgb(255, 255, 255);\n            border-radius: 5px;\n            padding: 15px;\n            box-shadow: 1px 0px 12px rgb(177, 177, 177);\n         }\n         \n         .error_header{\n            display: flex;\n            justify-content: center;\n            align-items: center;\n            border-bottom: 1px solid grey;\n         }\n         \n         h1{\n            color: rgb(248, 82, 82);\n         }\n         \n         p{\n            color: grey;\n         }\n         \n         .red-box{\n            background-color: rgba(255, 182, 182, 0.699);\n            color: rgb(255, 88, 88);\n            padding: 3px;\n            border-radius: 3px;\n            font-weight: 700;\n         }\n         \n         .red-box-l{\n            background-color: rgb(255, 174, 174);\n            color: rgb(247, 72, 72);\n            padding: 3px;\n            border-radius: 3px;\n            font-weight: 700;\n         }\n         \n         .r{\n            color: #65DBCA;\n         }\n         .p{\n            color: #C792EA\n         }\n         \n         .b{\n            color: #82AAE5\n         }\n         \n         .w{\n            color: #c9D1DF;\n         }\n         \n         .red{\n            color: red;\n         }\n         \n         .bg-code{\n            background-color: #011627;\n            color: rgb(1, 153, 22);\n            display: block;\n            padding: 5px;\n            border-radius: 5px;\n            font-weight: 700;\n            width: 100%;\n         }\n        </style>\n        <div class=\"error_body\"><div class=\"error_card\"><div class=\"error_header\"><h1>404 HTTP URL</h1></div><div class=\"error_desc\"><p><p class=\"red-box\">Routemamba rendering error !!</p>Did you forget to declare <span class=\"red-box\">http_url</span> on: </p><code class=\"bg-code\"><span class=\"r\">routemamba</span><span class=\"c\">.</span><span class=\"b\">route</span><span class=\"w\">({</span><br><br>&nbsp&nbsp <span class=\"w\">http_url:</span> <b class=\"red-box-l\">undefined</b> &nbsp <b class=\"red\"><<-- error !(undefined)</b><br><br><span class=\"w\">});</span></code><p>Set <span class=\"red-box\">http_url</span> to solve this problem</p><hr><p>Developed by: Rezwan Ahmod Sami</p></div></div></div>",
          __404_ServerHostErrorContent: "<style>\n         body{\n             margin: 0;\n             padding: 0;\n             background-color: rgb(245, 245, 245);\n          }\n          .error_body{\n             width: 100% !important;\n             height: 100% !important;\n             display: flex;\n             justify-content: center;\n             align-items: center;\n             margin-top: 20px;\n          }\n          \n          .error_card{\n             display: block;\n             width: 400px;\n             background-color: rgb(255, 255, 255);\n             border-radius: 5px;\n             padding: 15px;\n             box-shadow: 1px 0px 12px rgb(177, 177, 177);\n          }\n          \n          .error_header{\n             display: flex;\n             justify-content: center;\n             align-items: center;\n             border-bottom: 1px solid grey;\n          }\n          \n          h1{\n             color: rgb(248, 82, 82);\n          }\n          \n          p{\n             color: grey;\n          }\n          \n          .red-box{\n             background-color: rgba(255, 182, 182, 0.699);\n             color: rgb(255, 88, 88);\n             padding: 3px;\n             border-radius: 3px;\n             font-weight: 700;\n          }\n          \n          .red-box-l{\n             background-color: rgb(255, 174, 174);\n             color: rgb(247, 72, 72);\n             padding: 3px;\n             border-radius: 3px;\n             font-weight: 700;\n          }\n          \n          .r{\n             color: #65DBCA;\n          }\n          .p{\n             color: #C792EA\n          }\n          \n          .b{\n             color: #82AAE5\n          }\n          \n          .w{\n             color: #c9D1DF;\n          }\n          \n          .red{\n             color: red;\n          }\n          \n          .bg-code{\n             background-color: #011627;\n             color: rgb(1, 153, 22);\n             display: block;\n             padding: 5px;\n             border-radius: 5px;\n             font-weight: 700;\n             width: 100%;\n          }\n         </style><div class=\"error_body\"><div class=\"error_card\"><div class=\"error_header\"><h1>404 SERVER HOST</h1></div><div class=\"error_desc\"><p><p class=\"red-box\">Routemamba rendering error !!</p>Did you forget to declare <span class=\"red-box\">server_host</span> on: </p><code class=\"bg-code\"><span class=\"r\">routemamba</span><span class=\"c\">.</span><span class=\"b\">registerServerHost</span><span class=\"w\">(</span>&nbsp<b class=\"red-box-l\">undefined</b> ); <b class=\"red\"><<-- error!!!</b><br><br></span></code><p>Set <span class=\"red-box\">registerServerHost()</span> to solve this problem</p><hr><p>Developed by: Rezwan Ahmod Sami</p></div></div></div>",
      };
  })(PersistStorage || (PersistStorage = {}));

  /**
   * Node Script renderer @functions
   */
  var nodeScriptIs = function (node) {
      return node.tagName == 'SCRIPT';
  };
  var nodeScriptClone = function (node) {
      var script = document.createElement('script');
      script.text = node.innerHTML;
      var i = -1;
      var attrs = node.attributes;
      var attr;
      while (++i < attrs.length) {
          script.setAttribute((attr = attrs[i]).name, attr.value);
      }
      return script;
  };
  var nodeScriptReplace = function (node) {
      var _a;
      if (nodeScriptIs(node)) {
          (_a = node.parentNode) === null || _a === void 0 ? void 0 : _a.replaceChild(nodeScriptClone(node), node);
      }
      else {
          var i = -1;
          var children = node.childNodes;
          while (++i < children.length) {
              nodeScriptReplace(children[i]);
          }
      }
      return node;
  };
  var loadScript = function (container) {
      var nodes = document.querySelectorAll(container);
      if (nodes != null && nodes != undefined) {
          nodes.forEach(function (n) {
              nodeScriptReplace(n);
          });
      }
  };
  /**
   * This @function is for render dom content direct in body
   */
  var __render_DOM_root = function (content) {
      var body = document.querySelector('body');
      if (body == undefined) {
          // eslint-disable-next-line quotes
          throw new Error("Can't render DOM Root!!. DOM Root body tag not found.");
      }
      if (body == null) {
          // eslint-disable-next-line quotes
          throw new Error("Can't render DOM Root!!. DOM Root body tag not found.");
      }
      body.innerHTML = content;
      loadScript('body');
      return true;
  };
  /**
   * @function is for render DOM in specific container >>
   */
  var __render_DOM = function (container, content) {
      var dom = document.querySelector(container);
      if (dom == undefined) {
          throw new Error("Can't render DOM!!. ".concat(container, " Element not found."));
      }
      if (dom == null) {
          throw new Error("Can't render DOM!!. ".concat(container, " Element not found."));
      }
      dom.innerHTML = content;
      loadScript(container);
      return true;
  };
  var __render_state_value = function (container, content) {
      var doms = document.querySelectorAll(container);
      doms.forEach(function (dom) {
          if (dom == undefined) {
              throw new Error("Can't render state value!!. ".concat(container, " Element not found."));
          }
          if (dom == null) {
              throw new Error("Can't render state value!!. ".concat(container, " Element not found."));
          }
          dom.innerHTML = content;
      });
      loadScript(container);
      return true;
  };
  /**
   * @function for render dom head tag
   */
  var __render_DOM_head = function (content) {
      var headDom = document.querySelector('head');
      if (headDom == undefined) {
          // eslint-disable-next-line quotes
          throw new Error("Can't render DOM Root!!. DOM Root Head tag not found.");
      }
      if (headDom == null) {
          // eslint-disable-next-line quotes
          throw new Error("Can't render DOM Root!!. DOM Root Head tag not found.");
      }
      headDom.innerHTML = content;
      return true;
  };
  // generate body root element
  var generate_body_root_element = function () {
      var Root = document.querySelector("".concat(HtmlSelector.Root));
      if (Root == undefined || Root == null) {
          throw new Error("Can't render DOM Root!!. DOM Root ".concat(HtmlSelector.Root, " tag not found."));
      }
      var body_root = document.querySelector("".concat(HtmlSelector.Root, " ").concat(HtmlSelector.Body));
      if (body_root == undefined || body_root == null) {
          // create element
          var body_root_1 = document.createElement("".concat(HtmlSelector.Body));
          // append to Root
          Root.appendChild(body_root_1);
      }
  };
  // generate header root element
  var generate_header_root_element = function () {
      var Root = document.querySelector("".concat(HtmlSelector.Root));
      if (Root == undefined || Root == null) {
          throw new Error("Can't render DOM Root!!. DOM Root ".concat(HtmlSelector.Root, " tag not found."));
      }
      var header_root = document.querySelector("".concat(HtmlSelector.Root, " ").concat(HtmlSelector.Header));
      if (header_root == undefined || header_root == null) {
          // create element
          var header_root_1 = document.createElement("".concat(HtmlSelector.Header));
          // append to Root
          Root.appendChild(header_root_1);
      }
  };
  // generate footer root element
  var generate_footer_root_element = function () {
      var Root = document.querySelector("".concat(HtmlSelector.Root));
      if (Root == undefined || Root == null) {
          throw new Error("Can't render DOM Root!!. DOM Root ".concat(HtmlSelector.Root, " tag not found."));
      }
      var footer_root = document.querySelector("".concat(HtmlSelector.Root, " ").concat(HtmlSelector.Footer));
      if (footer_root == undefined || footer_root == null) {
          // create element
          var footer_root_1 = document.createElement("".concat(HtmlSelector.Footer));
          // append to Root
          Root.appendChild(footer_root_1);
      }
  };
  var generate_required_all_root_elements = function () {
      generate_header_root_element();
      generate_body_root_element();
      generate_footer_root_element();
  };

  var isValidUrl = function (str) {
      var pattern = new RegExp('^(https?://)?' + // protocol
          '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|' + // domain name
          '((\\d{1,3}\\.){3}\\d{1,3}))' + // OR ip (v4) address
          '(\\:\\d+)?(?:/[a-z\\d%_.~+]*)*' + // port and path
          '(?:\\?[;&a-z\\d%_.~+=-]*)?' + // query string
          '(?:\\#[-a-z\\d_]*)?$', 'i'); // fragment locator
      return !!pattern.test(str);
  };

  var isEmptyObject = function (obj) {
      return Object.keys(obj).length == 0;
  };

  /* eslint-disable @typescript-eslint/no-explicit-any */
  var parseQueryString = function (query) {
      var vars = query.split('&');
      var result = {};
      for (var i = 0; i < vars.length; i++) {
          var pair = vars[i].split('=');
          var key = decodeURIComponent(pair[0]);
          var value = decodeURIComponent(pair[1]);
          if (typeof result[key] === 'undefined') {
              result[key] = decodeURIComponent(value);
          }
          else if (typeof result[key] === 'string') {
              var arr = [result[key], decodeURIComponent(value)];
              result[key] = arr;
          }
          else {
              result[key].push(decodeURIComponent(value));
          }
      }
      return result;
  };

  /* eslint-disable @typescript-eslint/no-explicit-any */
  var parseObjectToQueryString = function (obj) {
      var data = '';
      if (obj != null) {
          var parsed_keys = Object.keys(obj);
          var parsed_values = Object.values(obj);
          for (var i = 0; i < parsed_keys.length; i++) {
              data += parsed_keys[i] + '=' + parsed_values[i];
              if (parsed_keys.length - 1 != i) {
                  data += '&';
              }
          }
      }
      return data;
  };

  var isValidServerHost = function (server_host) {
      return (server_host.includes(PersistStorage.NetworkConfig.localIp) ||
          server_host.includes(PersistStorage.NetworkConfig.localhost) ||
          server_host.includes(PersistStorage.NetworkConfig.localFilePath) ||
          server_host.includes(PersistStorage.NetworkConfig.tauriHost) ||
          isValidUrl(server_host));
  };

  // Define a function that takes two strings as inputs
  function checkPathParam(url, pattern) {
      // Split the url and the pattern by "/"
      var urlParts = url.split('/');
      var patternParts = pattern.split('/');
      // Check if the url and the pattern have the same length
      if (urlParts.length !== patternParts.length) {
          // If not, return null
          return null;
      }
      // Initialize an empty object to store the path parameter
      var param = {};
      // Loop through the url and the pattern parts
      for (var i = 0; i < urlParts.length; i++) {
          // Check if the current pattern part starts with ":"
          if (patternParts[i].startsWith(':')) {
              // If yes, extract the key name by removing the ":"
              var key = patternParts[i].slice(1);
              // Store the corresponding url part as the value for the key
              param[key] = urlParts[i];
          }
          else {
              // If no, check if the current url part matches the current pattern part
              if (urlParts[i] !== patternParts[i]) {
                  // If not, return null
                  return null;
              }
          }
      }
      // Return the path parameter object
      return param;
  }

  // Define a function that takes a string as input
  function isPathParamPattern(str) {
      // Check if the string starts with "/" and contains ":"
      if (str.startsWith('/') && str.includes(':')) {
          // Use the match method to split the string by "/" and ignore the empty strings
          var parts = str.match(/[^/]+/g);
          // Loop through the parts
          for (var _i = 0, _a = parts; _i < _a.length; _i++) {
              var part = _a[_i];
              // Check if the part contains more than one ":"
              if (part.split(':').length > 2) {
                  // If yes, return false
                  return false;
              }
          }
          // Return true if no part is invalid
          return true;
      }
      else {
          // Return false if the string does not start with "/" or does not contain ":"
          return false;
      }
  }

  /** there all validators @functions exporting for validate string, objects, arrays etc from one place  */
  var RmValidator = {
      isValidUrl: isValidUrl,
      isEmptyObject: isEmptyObject,
      parseQueryString: parseQueryString,
      parseObjectToQueryString: parseObjectToQueryString,
      isValidServerHost: isValidServerHost,
      checkPathParam: checkPathParam,
      isPathParamPattern: isPathParamPattern,
  };

  var PageRenderController = function () {
      var header_content = RoutesStorage.RouteContentsState.HeaderContent;
      var footer_content = RoutesStorage.RouteContentsState.FooterContent;
      var body_content = RoutesStorage.RouteContentsState.BodyContent;
      if (RoutesStorage.RouteContentsState.ShouldHeaderload &&
          RoutesStorage.RouteContentsState.ShouldFooterload &&
          header_content != null &&
          footer_content != null &&
          body_content != null) {
          if (RoutesStorage.RouteContentsState.ShouldHeaderload &&
              !RoutesStorage.RouteContentsState.renderStatus.header) {
              __render_DOM(HtmlSelector.Header, header_content);
              RoutesStorage.RouteContentsState.renderStatus.header = true;
          }
          if (!RoutesStorage.RouteContentsState.renderStatus.body) {
              __render_DOM(HtmlSelector.Body, body_content);
              RoutesStorage.RouteContentsState.renderStatus.body = true;
          }
          if (RoutesStorage.RouteContentsState.ShouldFooterload &&
              !RoutesStorage.RouteContentsState.renderStatus.footer) {
              __render_DOM(HtmlSelector.Footer, footer_content);
              RoutesStorage.RouteContentsState.renderStatus.footer = true;
          }
          if (RoutesStorage.RouteContentsState.HeaderContent != null &&
              RoutesStorage.RouteContentsState.BodyContent != null &&
              RoutesStorage.RouteContentsState.FooterContent != null) {
              RoutesStorage.RouteContentsState.HeaderContent = null;
              RoutesStorage.RouteContentsState.BodyContent = null;
              RoutesStorage.RouteContentsState.FooterContent = null;
          }
          if (RoutesStorage.RouteContentsState.navigationCallback != null &&
              RoutesStorage.RouteContentsState.navigationCallback != undefined) {
              RoutesStorage.RouteContentsState.navigationCallback();
          }
      }
      else if (!RoutesStorage.RouteContentsState.ShouldHeaderload &&
          RoutesStorage.RouteContentsState.ShouldFooterload &&
          header_content == null &&
          footer_content != null &&
          body_content != null) {
          if (!RoutesStorage.RouteContentsState.renderStatus.body) {
              __render_DOM(HtmlSelector.Body, body_content);
              RoutesStorage.RouteContentsState.renderStatus.body = true;
          }
          if (!RoutesStorage.RouteContentsState.renderStatus.footer) {
              __render_DOM(HtmlSelector.Footer, footer_content);
              RoutesStorage.RouteContentsState.renderStatus.footer = true;
          }
          if (RoutesStorage.RouteContentsState.navigationCallback != null &&
              RoutesStorage.RouteContentsState.navigationCallback != undefined) {
              RoutesStorage.RouteContentsState.navigationCallback();
          }
          if (RoutesStorage.RouteContentsState.FooterContent != null &&
              RoutesStorage.RouteContentsState.BodyContent != null) {
              RoutesStorage.RouteContentsState.FooterContent = null;
              RoutesStorage.RouteContentsState.BodyContent = null;
          }
      }
      else if (RoutesStorage.RouteContentsState.ShouldHeaderload &&
          !RoutesStorage.RouteContentsState.ShouldFooterload &&
          header_content != null &&
          footer_content == null &&
          body_content != null) {
          if (!RoutesStorage.RouteContentsState.renderStatus.header) {
              __render_DOM(HtmlSelector.Header, header_content);
              RoutesStorage.RouteContentsState.renderStatus.header = true;
          }
          if (!RoutesStorage.RouteContentsState.renderStatus.body) {
              __render_DOM(HtmlSelector.Body, body_content);
              RoutesStorage.RouteContentsState.renderStatus.body = true;
          }
          if (RoutesStorage.RouteContentsState.navigationCallback != null &&
              RoutesStorage.RouteContentsState.navigationCallback != undefined) {
              RoutesStorage.RouteContentsState.navigationCallback();
          }
          if (RoutesStorage.RouteContentsState.HeaderContent != null &&
              RoutesStorage.RouteContentsState.BodyContent != null) {
              RoutesStorage.RouteContentsState.HeaderContent = null;
              RoutesStorage.RouteContentsState.BodyContent = null;
          }
      }
      else if (!RoutesStorage.RouteContentsState.ShouldHeaderload &&
          !RoutesStorage.RouteContentsState.ShouldFooterload &&
          header_content == null &&
          footer_content == null &&
          body_content != null) {
          if (!RoutesStorage.RouteContentsState.renderStatus.body) {
              __render_DOM(HtmlSelector.Body, body_content);
              RoutesStorage.RouteContentsState.renderStatus.body = true;
          }
          if (RoutesStorage.RouteContentsState.navigationCallback != null &&
              RoutesStorage.RouteContentsState.navigationCallback != undefined) {
              RoutesStorage.RouteContentsState.navigationCallback();
          }
          if (RoutesStorage.RouteContentsState.BodyContent != null) {
              RoutesStorage.RouteContentsState.BodyContent = null;
          }
      }
      /**
       * check all @rendered successfully or not, if @rendered successfully
       * then reset the @status again
       */
      var shouldResetFlags = RoutesStorage.RouteContentsState.ShouldHeaderload &&
          RoutesStorage.RouteContentsState.renderStatus.header &&
          RoutesStorage.RouteContentsState.renderStatus.body &&
          RoutesStorage.RouteContentsState.ShouldFooterload &&
          RoutesStorage.RouteContentsState.renderStatus.footer;
      var shouldResetFlagsAlt1 = !RoutesStorage.RouteContentsState.ShouldHeaderload &&
          !RoutesStorage.RouteContentsState.renderStatus.header &&
          !RoutesStorage.RouteContentsState.ShouldFooterload &&
          !RoutesStorage.RouteContentsState.renderStatus.footer &&
          RoutesStorage.RouteContentsState.renderStatus.body;
      var shouldResetFlagsAlt2 = RoutesStorage.RouteContentsState.ShouldHeaderload &&
          RoutesStorage.RouteContentsState.renderStatus.header &&
          !RoutesStorage.RouteContentsState.ShouldFooterload &&
          !RoutesStorage.RouteContentsState.renderStatus.footer &&
          RoutesStorage.RouteContentsState.renderStatus.body;
      var shouldResetFlagsAlt3 = !RoutesStorage.RouteContentsState.ShouldHeaderload &&
          !RoutesStorage.RouteContentsState.renderStatus.header &&
          RoutesStorage.RouteContentsState.ShouldFooterload &&
          RoutesStorage.RouteContentsState.renderStatus.footer &&
          RoutesStorage.RouteContentsState.renderStatus.body;
      if (shouldResetFlags ||
          shouldResetFlagsAlt1 ||
          shouldResetFlagsAlt2 ||
          shouldResetFlagsAlt3) {
          RoutesStorage.RouteContentsState.renderStatus.header = false;
          RoutesStorage.RouteContentsState.renderStatus.body = false;
          RoutesStorage.RouteContentsState.renderStatus.footer = false;
      }
  };
  var store_content = function (component_type, content) {
      switch (component_type) {
          case RouteComponentTypes.HEADER:
              RoutesStorage.RouteContentsState.HeaderContent = content;
              break;
          case RouteComponentTypes.BODY:
              RoutesStorage.RouteContentsState.BodyContent = content;
              break;
          case RouteComponentTypes.FOOTER:
              RoutesStorage.RouteContentsState.FooterContent = content;
              break;
      }
      PageRenderController();
  };

  /* eslint-disable @typescript-eslint/no-unused-vars */
  var RouteEngineInit = function (Input) {
      var current_url = window.location.href;
      var addPreloader = function () {
          if (Input.preloader != undefined &&
              Input.preloader != '' &&
              Input.container != undefined) {
              __render_DOM(Input.container, Input.preloader);
          }
      };
      switch (Input.component_type) {
          case RouteComponentTypes.HEADER:
              Input.container = HtmlSelector.Header;
              break;
          case RouteComponentTypes.BODY:
              Input.container = HtmlSelector.Body;
              break;
          case RouteComponentTypes.FOOTER:
              Input.container = HtmlSelector.Footer;
              break;
          case RouteComponentTypes.ON_DEMAND_TABVIEW:
              Input.container = HtmlSelector.OnDemandTabView;
              var OnDemandTabViewElement = document.querySelector("".concat(Input.container));
              if (OnDemandTabViewElement == undefined ||
                  OnDemandTabViewElement == null) {
                  throw new Error("<on-demand-tab-view> tag not found. can't load on-demand tab view. see documentation for more details. ".concat(exports.Info.documentation));
              }
              break;
      }
      if (Input.server_host != '') {
          var isValidServerHost = RmValidator.isValidServerHost(Input.server_host);
          if (!isValidServerHost) {
              alert('The server host is invalid');
          }
          else {
              if (Input.server_host.includes(PersistStorage.NetworkConfig.https_www) ||
                  Input.server_host.includes(PersistStorage.NetworkConfig.http_www)) {
                  var split_url = current_url.split('/');
                  var new_url = '';
                  for (var i = 0; i < 3; i++) {
                      if (i == 1) {
                          new_url += '//';
                      }
                      else {
                          new_url += split_url[i];
                      }
                  }
                  new_url += '/';
                  if (Input.http_url == Input.server_host) {
                      Input.http_url = new_url;
                  }
                  Input.server_host = new_url;
              }
              else if (Input.server_host.includes(PersistStorage.NetworkConfig.localIp) ||
                  Input.server_host.includes(PersistStorage.NetworkConfig.localhost)) {
                  if (current_url.includes(PersistStorage.NetworkConfig.localIp)) {
                      if (Input.server_host.includes(PersistStorage.NetworkConfig.localhost)) {
                          Input.server_host = Input.server_host.replace(PersistStorage.NetworkConfig.localhost, PersistStorage.NetworkConfig.localIp);
                      }
                  }
                  else if (current_url.includes(PersistStorage.NetworkConfig.localhost)) {
                      if (Input.server_host.includes(PersistStorage.NetworkConfig.localIp)) {
                          Input.server_host = Input.server_host.replace(PersistStorage.NetworkConfig.localIp, PersistStorage.NetworkConfig.localhost);
                      }
                  }
              }
              else {
                  var split_server_host = Input.server_host.split('/');
                  var new_host = '';
                  for (var x = 0; x < split_server_host.length; x++) {
                      if ((x == 0 && split_server_host[x] == 'https:') ||
                          split_server_host[x] == 'http:') {
                          new_host = split_server_host[x] + '/';
                          continue;
                      }
                      if (x == 1 &&
                          (current_url.includes(PersistStorage.NetworkConfig.http_www) ||
                              Input.server_host.includes(PersistStorage.NetworkConfig.http_www))) {
                          new_host += 'www.';
                      }
                      if (split_server_host[x] == '') {
                          new_host += '/';
                          continue;
                      }
                      new_host += split_server_host[x];
                  }
                  if (Input.http_url == Input.server_host) {
                      Input.http_url = new_host;
                  }
                  Input.server_host = new_host;
              }
          }
      }
      if (Input.http_url_change) {
          if (Input.http_url != undefined) {
              if (Input.http_url == '') {
                  Input.http_url = Input.server_host;
              }
              window.history.pushState(Input.server_host, '', Input.http_url);
              var http_url = '';
              if (Input.http_url.includes(Input.server_host) &&
                  Input.server_host != '') {
                  http_url = Input.http_url;
              }
              else {
                  http_url = Input.server_host + Input.http_url;
              }
              RoutesStorage.last_http_url = http_url;
              // console.log("last http url changed to: ", RoutesStorage.last_http_url);
          }
      }
      else if (Input.is_from_history == true) {
          // console.log("yes its from history");
          if (Input.http_url != undefined) {
              if (Input.http_url == '') {
                  Input.http_url = Input.server_host;
              }
              var http_url = '';
              if (Input.http_url.includes(Input.server_host) &&
                  Input.server_host != '') {
                  http_url = Input.http_url;
              }
              else {
                  http_url = Input.server_host + Input.http_url;
              }
              RoutesStorage.last_http_url = http_url;
              // console.log("last http url changed to: ", RoutesStorage.last_http_url);
          }
      }
      if (Input.container != '' &&
          Input.container != undefined &&
          Input.content_url != '') {
          var xhttp = new XMLHttpRequest();
          // add preloader
          addPreloader();
          xhttp.onprogress = function () {
              // void
          };
          xhttp.onload = function (e) {
              if (RenderConfig.await_rendering &&
                  Input.component_type != RouteComponentTypes.TAB &&
                  Input.component_type != RouteComponentTypes.ON_DEMAND_TABVIEW &&
                  Input.component_type != RouteComponentTypes.META) {
                  // if any kind of error status then store error-content else store response
                  if (this.status >= 400) {
                      store_content(Input.component_type, Input.error_content);
                      throw new Error("Error ".concat(this.status, ": ").concat(this.statusText));
                  }
                  store_content(Input.component_type, this.response);
              }
              else {
                  if (Input.container != undefined) {
                      // if any kind of error status then store error-content else store response
                      if (this.status >= 400) {
                          __render_DOM(Input.container, Input.error_content);
                          throw new Error("Error ".concat(this.status, ": ").concat(this.statusText));
                      }
                      __render_DOM(Input.container, this.response);
                      // check its on demand tab view or not
                      if (Input.component_type == RouteComponentTypes.ON_DEMAND_TABVIEW) {
                          if (OnDemandTabViewStorage.states.RequestedTabViewid != null) {
                              OnDemandTabViewStorage.RegisterdTabViewsContents.push({
                                  TabViewId: OnDemandTabViewStorage.states.RequestedTabViewid,
                                  TabViewContent: this.response,
                              });
                          }
                      }
                  }
              }
          };
          // eslint-disable-next-line @typescript-eslint/no-unused-vars
          xhttp.onerror = function (e) {
              if (Input.container != undefined) {
                  __render_DOM(Input.container, Input.error_content);
              }
              throw new Error(this.response);
          };
          var finalData = '';
          if (Input.method == 'POST') {
              finalData = RmValidator.parseObjectToQueryString(Input.data);
          }
          else if (Input.method == 'GET') {
              if (RoutesStorage.meta_content_url == Input.content_url) {
                  if (!RmValidator.isEmptyObject(Input.data)) {
                      var exist_q_mark = Input.content_url.includes('?');
                      if (exist_q_mark) {
                          var split_c_u = Input.content_url.split('?');
                          if (split_c_u[split_c_u.length - 1] != '' &&
                              split_c_u[split_c_u.length - 1] != undefined) {
                              Input.content_url += '&';
                          }
                      }
                      else {
                          Input.content_url += '?';
                      }
                  }
                  Input.content_url += RmValidator.parseObjectToQueryString(Input.data);
              }
          }
          xhttp.open(Input.method, Input.content_url);
          if (Input.method == 'POST') {
              xhttp.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
          }
          xhttp.send(finalData);
      }
      else {
          throw new Error('Container or Content Url is not defined.');
      }
  };
  var route = function (Route) {
      var split_http_url = [];
      var RouteHttpUrl = Route.http_url;
      var RouteContentUrl = Route.content_url;
      var RouteData = {};
      if (Route.PathParamData != undefined ||
          (Route.PathParamData == null && typeof Route.PathParamData == 'object')) {
          Object.assign(RouteData, Route.PathParamData);
      }
      if (Route.http_url != undefined) {
          split_http_url = Route.http_url.split('?');
      }
      else {
          __render_DOM_head(PersistStorage.DomContent.ErrorHeadContent);
          __render_DOM_root(PersistStorage.DomContent.__404_urlErrorContent);
      }
      if (split_http_url[1] != undefined) {
          var queryData = RmValidator.parseQueryString(split_http_url[1]);
          if (!RmValidator.isEmptyObject(queryData)) {
              // Loop through the keys in queryData
              for (var key in queryData) {
                  // Check if the key doesn't exist in RouteData
                  if (!RouteData.hasOwnProperty(key)) {
                      // Assign the key-value pair from queryData to RouteData
                      RouteData[key] = queryData[key];
                  }
              }
          }
          var query = RmValidator.parseObjectToQueryString(RouteData);
          if (RouteContentUrl.includes('?')) {
              RouteContentUrl = RouteContentUrl + '&' + query;
          }
          else {
              RouteContentUrl = RouteContentUrl + '?' + query;
          }
      }
      else if (Route.data != undefined &&
          Route.data != null &&
          !RmValidator.isEmptyObject(Route.data)) {
          Object.assign(RouteData, Route.data);
          var query1 = RmValidator.parseObjectToQueryString(Route.data);
          var query2 = RmValidator.parseObjectToQueryString(RouteData);
          if (RouteContentUrl.includes('?')) {
              RouteContentUrl = RouteContentUrl + '&' + query2;
          }
          else {
              RouteContentUrl = RouteContentUrl + '?' + query2;
          }
          if (RouteHttpUrl.includes('?')) {
              RouteContentUrl = RouteHttpUrl + '&' + query1;
          }
          else {
              RouteHttpUrl = RouteHttpUrl + '?' + query1;
          }
      }
      else if (split_http_url[1] == undefined &&
          ((Route.data == undefined && Route.data == null) ||
              RmValidator.isEmptyObject(Route.data)) &&
          !RmValidator.isEmptyObject(RouteData)) {
          // console.log("condition accepted")
          var query = RmValidator.parseObjectToQueryString(RouteData);
          if (RouteContentUrl.includes('?')) {
              RouteContentUrl = RouteContentUrl + '&' + query;
          }
          else {
              RouteContentUrl = RouteContentUrl + '?' + query;
          }
      }
      if (Route.meta_loader) {
          MetaLoader(RouteHttpUrl, Route.registered_url_pattern);
      }
      var RouteEngineInput = {
          method: Route.method,
          content_url: RouteContentUrl,
          component_type: Route.component_type,
          container: Route.container,
          preloader: Route.preloader,
          error_content: Route.error_content,
          data: RouteData,
          http_url_change: Route.http_url_change,
          server_host: RoutesStorage.server_host,
          http_url: RouteHttpUrl,
          is_from_history: Route.is_from_history
      };
      if (Route.http_url_change != undefined && !Route.http_url_change) {
          RouteEngineInit(RouteEngineInput);
      }
      else if (Route.http_url_change) {
          if (RoutesStorage.server_host != undefined &&
              RoutesStorage.server_host != '') {
              RouteEngineInit(RouteEngineInput);
          }
          else {
              __render_DOM_head(PersistStorage.DomContent.ErrorHeadContent);
              __render_DOM_root(PersistStorage.DomContent.__404_ServerHostErrorContent);
          }
      }
  };

  /**
   * @functions
   */
  var renderHeader = function () {
      var current_http_url = window.location.href;
      var url = new URL(current_http_url);
      var route_path = url.pathname + url.search;
      var get_route_param = route_path.split('?');
      // if in url in last char exist any / then remove it
      if (get_route_param[0].length > 1 &&
          get_route_param[0][get_route_param[0].length - 1] == '/') {
          get_route_param[0] = get_route_param[0].slice(0, -1);
      }
      var data = {};
      if (get_route_param[1] != undefined) {
          data = RmValidator.parseQueryString(get_route_param[1]);
      }
      var found = false;
      if (RoutesStorage.RoutesHeaders.length == 0) {
          RoutesStorage.RouteContentsState.ShouldHeaderload = false;
          RoutesStorage.RouteContentsState.HeaderContent = null;
      }
      for (var Hindex = 0; Hindex < RoutesStorage.RoutesHeaders.length; Hindex++) {
          var Hroute = RoutesStorage.RoutesHeaders[Hindex];
          for (var i = 0; i < Hroute.http_url.length; i++) {
              var http_url = Hroute.http_url[i];
              if (http_url == get_route_param[0] ||
                  RmValidator.checkPathParam(get_route_param[0], http_url) != null) {
                  var registered_url_pattern = http_url;
                  var PathParamData = RmValidator.checkPathParam(get_route_param[0], http_url);
                  var content_path = Hroute.content_url;
                  var route_split = content_path.split('?');
                  var content_url = route_split[0];
                  var Route = {
                      method: 'GET',
                      meta_loader: false,
                      content_url: content_url,
                      component_type: RouteComponentTypes.HEADER,
                      preloader: Hroute.preloader,
                      data: data,
                      PathParamData: PathParamData,
                      error_content: Hroute.error_content,
                      http_url_change: false,
                      http_url: route_path,
                      registered_url_pattern: registered_url_pattern,
                  };
                  route(Route);
                  found = true;
                  break;
              }
              else if (http_url != get_route_param[0] &&
                  i == Hroute.http_url.length - 1 &&
                  Hindex == RoutesStorage.RoutesHeaders.length - 1) {
                  RoutesStorage.RouteContentsState.ShouldHeaderload = false;
                  RoutesStorage.RouteContentsState.HeaderContent = null;
              }
          }
          if (found) {
              break;
          }
      }
  };
  var renderBody = function () {
      var current_http_url = window.location.href;
      var url = new URL(current_http_url);
      var route_path = url.pathname + url.search;
      var get_route_param = route_path.split('?');
      // if in url in last char exist any / then remove it
      if (get_route_param[0].length > 1 &&
          get_route_param[0][get_route_param[0].length - 1] == '/') {
          get_route_param[0] = get_route_param[0].slice(0, -1);
      }
      var data = {};
      if (get_route_param[1] != undefined) {
          data = RmValidator.parseQueryString(get_route_param[1]);
      }
      for (var i = 0; i < RoutesStorage.RoutesPages.length; i++) {
          var Broute = RoutesStorage.RoutesPages[i];
          var http_url = Broute.http_url;
          if (http_url == get_route_param[0] ||
              RmValidator.checkPathParam(get_route_param[0], http_url) != null) {
              var registered_url_pattern = http_url;
              var PathParamData = RmValidator.checkPathParam(get_route_param[0], http_url);
              var route_content_url = '';
              if (Broute.method == 'GET') {
                  var content_path = Broute.content_url;
                  var route_split = content_path.split('?');
                  route_content_url = "".concat(route_split[0]);
              }
              var meta_loader = true;
              var Route = {
                  method: Broute.method,
                  meta_loader: meta_loader,
                  content_url: route_content_url,
                  component_type: RouteComponentTypes.BODY,
                  container: Broute.container,
                  preloader: Broute.preloader,
                  data: data,
                  PathParamData: PathParamData,
                  error_content: Broute.error_content,
                  http_url_change: Broute.http_url_change,
                  http_url: route_path,
                  registered_url_pattern: registered_url_pattern,
                  is_from_history: true
              };
              // console.log(Route);
              route(Route);
              break;
          }
          else if (http_url != get_route_param[0] &&
              i === RoutesStorage.RoutesPages.length - 1) {
              __render_DOM_root("No any Register route found: ".concat(get_route_param[0]));
              throw new Error("No any Register route found: ".concat(get_route_param[0]));
          }
      }
  };
  var renderFooter = function () {
      var current_http_url = window.location.href;
      var url = new URL(current_http_url);
      var route_path = url.pathname + url.search;
      var get_route_param = route_path.split('?');
      // if in url in last char exist any / then remove it
      if (get_route_param[0].length > 1 &&
          get_route_param[0][get_route_param[0].length - 1] == '/') {
          get_route_param[0] = get_route_param[0].slice(0, -1);
      }
      var data = {};
      if (get_route_param[1] != undefined) {
          data = RmValidator.parseQueryString(get_route_param[1]);
      }
      var found = false;
      if (RoutesStorage.RoutesFooters.length == 0) {
          RoutesStorage.RouteContentsState.ShouldFooterload = false;
          RoutesStorage.RouteContentsState.FooterContent = null;
      }
      for (var Findex = 0; Findex < RoutesStorage.RoutesFooters.length; Findex++) {
          var Froute = RoutesStorage.RoutesFooters[Findex];
          for (var i = 0; i < Froute.http_url.length; i++) {
              var http_url = Froute.http_url[i];
              if (http_url == get_route_param[0] ||
                  RmValidator.checkPathParam(get_route_param[0], http_url) != null) {
                  var registered_url_pattern = http_url;
                  var PathParamData = RmValidator.checkPathParam(get_route_param[0], http_url);
                  var content_path = Froute.content_url;
                  var route_split = content_path.split('?');
                  var content_url = route_split[0];
                  var Route = {
                      method: 'GET',
                      meta_loader: false,
                      content_url: content_url,
                      component_type: RouteComponentTypes.FOOTER,
                      preloader: Froute.preloader,
                      data: data,
                      PathParamData: PathParamData,
                      error_content: Froute.error_content,
                      http_url_change: false,
                      http_url: route_path,
                      registered_url_pattern: registered_url_pattern,
                  };
                  route(Route);
                  found = true;
                  break;
              }
              else if (http_url != get_route_param[0] &&
                  i == Froute.http_url.length - 1 &&
                  Findex == RoutesStorage.RoutesFooters.length - 1) {
                  RoutesStorage.RouteContentsState.ShouldFooterload = false;
                  RoutesStorage.RouteContentsState.FooterContent = null;
              }
          }
          if (found) {
              break;
          }
      }
  };
  var render$1 = function () {
      generate_required_all_root_elements();
      renderHeader();
      renderFooter();
      renderBody();
  };
  var await_rendering = function (status) {
      RenderConfig.await_rendering = status;
  };

  /* eslint-disable @typescript-eslint/no-explicit-any */
  var MetaLoader = function (httpUrl, RegisteredUrlPattern) {
      if (RoutesStorage.meta_content_url != undefined &&
          RoutesStorage.meta_content_url != '') {
          var get_route_param = httpUrl.split('?');
          // if in url in last char exist any / then remove it
          if (get_route_param[0][get_route_param[0].length - 1] == '/') {
              get_route_param[0] = get_route_param[0].slice(0, -1);
          }
          var query_data = {};
          if (RegisteredUrlPattern != undefined &&
              RmValidator.checkPathParam(get_route_param[0], RegisteredUrlPattern) !=
                  null) {
              var PathParam = RmValidator.checkPathParam(get_route_param[0], RegisteredUrlPattern);
              if (PathParam != null && !RmValidator.isEmptyObject(PathParam)) {
                  Object.assign(query_data, PathParam);
              }
          }
          if (httpUrl == undefined || httpUrl == '') {
              if (get_route_param.length > 1) {
                  var q_data = RmValidator.parseQueryString(get_route_param[1]);
                  if (!RmValidator.isEmptyObject(q_data)) {
                      Object.assign(query_data, q_data);
                  }
              }
              query_data.route = '/';
          }
          else {
              if (get_route_param.length > 1) {
                  var q_data = RmValidator.parseQueryString(get_route_param[1]);
                  if (!RmValidator.isEmptyObject(q_data)) {
                      Object.assign(query_data, q_data);
                  }
              }
              query_data.route =
                  RegisteredUrlPattern != undefined
                      ? RegisteredUrlPattern
                      : get_route_param[0];
          }
          var RouteEngineInput = {
              method: 'GET',
              content_url: RoutesStorage.meta_content_url,
              component_type: RouteComponentTypes.META,
              container: 'head meta',
              preloader: '',
              error_content: '',
              data: query_data,
              http_url_change: false,
              server_host: RoutesStorage.server_host,
              http_url: '',
          };
          RouteEngineInit(RouteEngineInput);
      }
      else {
          __render_DOM_root(PersistStorage.DomContent.DefineMetaUrlError);
          throw new Error(PersistStorage.DomContent.DefineMetaUrlError);
      }
  };
  var historyRoutesLoader = function (status) {
      if (status) {
          // console.log('historyRoutesLoader called');
          // console.log('LAST HTTP URL: ', RoutesStorage.last_http_url);
          // console.log('last_http_url_path: ', last_http_url_path);
          var current_http_url = window.location.href;
          var url = new URL(current_http_url);
          var route_path = url.pathname + url.search;
          var get_route_param = route_path.split('?');
          // console.log('current_http_url: ', current_http_url);
          // console.log('route pth: ', route_path);
          // suppress render if last_http_url_path and route_path is same
          var last_http_url = RoutesStorage.last_http_url;
          if (last_http_url != undefined && last_http_url != '') {
              // console.log(last_http_url);
              var last_http_url_breakdown = new URL(last_http_url);
              // console.log(last_http_url_breakdown);
              var last_http_url_path = last_http_url_breakdown.pathname + last_http_url_breakdown.search;
              if (last_http_url_path == route_path) {
                  // console.log("last http url and route path is same", last_http_url, route_path);
                  return;
              }
          }
          var RoutePages = RoutesStorage.RoutesPages;
          for (var i = 0; i < RoutePages.length; i++) {
              var http_url = RoutePages[i].http_url;
              if (http_url == get_route_param[0] ||
                  RmValidator.isPathParamPattern(http_url)) {
                  if (RoutesStorage.RouteContentsState.ShouldHeaderload) {
                      renderHeader();
                  }
                  renderBody();
                  if (RoutesStorage.RouteContentsState.ShouldFooterload) {
                      renderFooter();
                  }
                  break;
              }
          }
      }
  };

  var register_http_routes = function (Routes) {
      RoutesStorage.RoutesPages = Routes;
      if (typeof window !== 'undefined') {
          window.addEventListener('popstate', function () {
              historyRoutesLoader(true);
          });
      }
  };
  var register_routes_headers = function (Headers) {
      RoutesStorage.RoutesHeaders = Headers;
  };
  var register_routes_footers = function (Footers) {
      RoutesStorage.RoutesFooters = Footers;
  };
  var registerServerHost = function (ServerHost) {
      RoutesStorage.server_host = ServerHost;
  };
  var registerMetaUrl = function (MetaUrl) {
      RoutesStorage.meta_content_url = MetaUrl;
  };

  var navigate = function (route_to, data, options, callback) {
      if (data === void 0) { data = null; }
      if (options === void 0) { options = {}; }
      if (callback === void 0) { callback = null; }
      RoutesStorage.RouteContentsState.navigationCallback = callback;
      RoutesStorage.RouteContentsState.ShouldHeaderload = false;
      RoutesStorage.RouteContentsState.ShouldFooterload = false;
      if (route_to != null || route_to != undefined) {
          var r = RoutesStorage.RoutesPages;
          for (var i = 0; i < r.length; i++) {
              var http_url = route_to;
              var split_route_to = route_to.split('?')[0];
              // if in url in last char exist any / then remove it
              if (split_route_to.length > 1 &&
                  split_route_to[split_route_to.length - 1] == '/') {
                  split_route_to = split_route_to.slice(0, -1);
              }
              if (split_route_to != undefined &&
                  (split_route_to == r[i].http_url ||
                      RmValidator.checkPathParam(split_route_to, r[i].http_url) != null)) {
                  var h_url = r[i].http_url;
                  var registered_url_pattern = h_url;
                  var http_url_change = true;
                  var method = r[i].method;
                  var meta_loader = r[i].meta_loader;
                  var PathParamData = RmValidator.checkPathParam(split_route_to, r[i].http_url);
                  if (data == null) {
                      data = {};
                  }
                  // setting / root path to blank, so it can be define dir as  root path
                  if (route_to == '/') {
                      http_url = '';
                  }
                  if (options.meta_loader != undefined &&
                      typeof options.meta_loader === 'boolean') {
                      meta_loader = options.meta_loader;
                  }
                  if (options.http_url_change != undefined &&
                      typeof options.http_url_change === 'boolean') {
                      http_url_change = options.http_url_change;
                  }
                  if (options.method != undefined && options.method != '') {
                      method = options.method;
                  }
                  if (options.header_load != undefined &&
                      typeof options.header_load === 'boolean') {
                      RoutesStorage.RouteContentsState.ShouldHeaderload =
                          options.header_load;
                      if (options.header_load) {
                          if (RoutesStorage.RoutesHeaders.length == 0) {
                              RoutesStorage.RouteContentsState.ShouldHeaderload = false;
                              RoutesStorage.RouteContentsState.HeaderContent = null;
                          }
                          for (var hIndex = 0; hIndex < RoutesStorage.RoutesHeaders.length; hIndex++) {
                              var h = RoutesStorage.RoutesHeaders[hIndex];
                              var found = false;
                              for (var i_1 = 0; i_1 < h.http_url.length; i_1++) {
                                  if (h.http_url[i_1] == h_url) {
                                      var Route_1 = {
                                          method: 'GET',
                                          meta_loader: false,
                                          content_url: h.content_url,
                                          component_type: RouteComponentTypes.HEADER,
                                          preloader: h.preloader,
                                          data: data,
                                          PathParamData: PathParamData,
                                          error_content: h.error_content,
                                          http_url_change: false,
                                          http_url: http_url,
                                          registered_url_pattern: registered_url_pattern,
                                      };
                                      route(Route_1);
                                      found = true;
                                      break;
                                  }
                                  else if (h.http_url[i_1] != h_url &&
                                      i_1 == h.http_url.length - 1 &&
                                      hIndex == RoutesStorage.RoutesHeaders.length - 1) {
                                      RoutesStorage.RouteContentsState.ShouldHeaderload = false;
                                      RoutesStorage.RouteContentsState.HeaderContent = null;
                                  }
                              }
                              if (found) {
                                  break;
                              }
                          }
                      }
                  }
                  if (options.footer_load != undefined &&
                      typeof options.footer_load === 'boolean') {
                      RoutesStorage.RouteContentsState.ShouldFooterload =
                          options.footer_load;
                      if (options.footer_load) {
                          if (RoutesStorage.RoutesFooters.length == 0) {
                              RoutesStorage.RouteContentsState.ShouldFooterload = false;
                              RoutesStorage.RouteContentsState.FooterContent = null;
                          }
                          for (var fIndex = 0; fIndex < RoutesStorage.RoutesFooters.length; fIndex++) {
                              var f = RoutesStorage.RoutesFooters[fIndex];
                              var found = false;
                              for (var i_2 = 0; i_2 < f.http_url.length; i_2++) {
                                  if (f.http_url[i_2] == h_url) {
                                      var Route_2 = {
                                          method: 'GET',
                                          meta_loader: false,
                                          content_url: f.content_url,
                                          component_type: RouteComponentTypes.FOOTER,
                                          preloader: f.preloader,
                                          data: data,
                                          PathParamData: PathParamData,
                                          error_content: f.error_content,
                                          http_url_change: false,
                                          http_url: http_url,
                                          registered_url_pattern: registered_url_pattern,
                                      };
                                      route(Route_2);
                                      found = true;
                                      break;
                                  }
                                  else if (f.http_url[i_2] != h_url &&
                                      i_2 == f.http_url.length - 1 &&
                                      fIndex == RoutesStorage.RoutesFooters.length - 1) {
                                      RoutesStorage.RouteContentsState.ShouldFooterload = false;
                                      RoutesStorage.RouteContentsState.FooterContent = null;
                                  }
                              }
                              if (found) {
                                  break;
                              }
                          }
                      }
                  }
                  var Route = {
                      method: method,
                      meta_loader: meta_loader,
                      content_url: r[i].content_url,
                      component_type: RouteComponentTypes.BODY,
                      preloader: r[i].preloader,
                      data: data,
                      PathParamData: PathParamData,
                      error_content: r[i].error_content,
                      http_url_change: http_url_change,
                      http_url: http_url,
                      registered_url_pattern: registered_url_pattern,
                  };
                  route(Route);
                  break;
              }
              else if (!route_to.includes(r[i].http_url) &&
                  i == RoutesStorage.RoutesPages.length - 1) {
                  throw new Error("".concat(route_to, " is not a registered routes."));
              }
          }
      }
      else {
          throw Error(PersistStorage.DomContent.NavigateRoutePathUndefined);
      }
  };
  var pop_route = function () {
      history.back();
  };
  var push_route = function () {
      history.go(1);
  };

  /**
   *
   * @param RegisterdTabs >> @type TabRegister
   */
  var initTabs = function (RegisterdTabs) {
      RegisterdTabs.forEach(function (regTab) {
          if (regTab.tabSwitcher == undefined || regTab.tabSwitcher == '') {
              throw new Error(
              // eslint-disable-next-line quotes
              "`tabSwitcher` field can't be undefined or empty in Tabs register.");
          }
          if (regTab.initialTab == undefined || regTab.initialTab == '') {
              throw new Error(
              // eslint-disable-next-line quotes
              "`initialTab` field can't be undefined or empty in Tabs register.");
          }
          if (regTab.tabs == undefined) {
              // eslint-disable-next-line quotes
              throw new Error("`tabs` field can't be undefined in Tabs register.");
          }
          var tabSwitcher = document.querySelectorAll(regTab.tabSwitcher);
          tabSwitcher.forEach(function (switcher) {
              var _a;
              // check tabRoute matched with initial tab or not
              if (switcher.getAttribute('tabRoute') == regTab.initialTab) {
                  if (document.querySelector(".".concat(regTab.activeSwitcherClass)) != null &&
                      document.querySelector(".".concat(regTab.activeSwitcherClass)) != undefined) {
                      (_a = document
                          .querySelector(".".concat(regTab.activeSwitcherClass))) === null || _a === void 0 ? void 0 : _a.classList.remove(regTab.activeSwitcherClass);
                  }
                  /**
                   * @param tabRoute if matched
                   * then add @param activeSwitcherClass
                   *
                   * @param activeSwitcherClass adding into switcher
                   */
                  switcher.classList.add(regTab.activeSwitcherClass);
              }
              /**
               * @addEventListener to each switcher class
               * @click event listener will be add
               */
              switcher.addEventListener('click', function () {
                  var _a, _b, _c, _d;
                  /**
                   * get @tabRoute on every @click event
                   */
                  var tabRoute = switcher.getAttribute('tabRoute');
                  if (tabRoute != undefined) {
                      if (document.querySelector(".".concat(regTab.activeSwitcherClass)) != null &&
                          document.querySelector(".".concat(regTab.activeSwitcherClass)) !=
                              undefined) {
                          (_a = document
                              .querySelector(".".concat(regTab.activeSwitcherClass))) === null || _a === void 0 ? void 0 : _a.classList.remove(regTab.activeSwitcherClass);
                      }
                      switcher.classList.add(regTab.activeSwitcherClass);
                      /**
                       * activating @tabComponent
                       */
                      var tabComponent = document.getElementById(tabRoute);
                      if (tabComponent != null && tabComponent != undefined) {
                          if (regTab.activeTabClass != undefined &&
                              regTab.activeTabClass != null &&
                              regTab.activeTabClass != '') {
                              (_b = document
                                  .querySelector(".".concat(regTab.activeTabClass))) === null || _b === void 0 ? void 0 : _b.classList.remove(regTab.activeTabClass);
                              tabComponent.classList.add(regTab.activeTabClass);
                          }
                          else {
                              (_c = document
                                  .querySelector('.rm-tab-active')) === null || _c === void 0 ? void 0 : _c.style.setProperty('display', '', '');
                              (_d = document
                                  .querySelector('.rm-tab-active')) === null || _d === void 0 ? void 0 : _d.classList.remove('rm-tab-active');
                              tabComponent.style.setProperty('display', 'block', 'important');
                              tabComponent.classList.add('rm-tab-active');
                          }
                      }
                      else {
                          throw new Error(
                          // eslint-disable-next-line quotes
                          '`' + tabRoute + "` tabRoute container can't be undefined.");
                      }
                  }
                  else {
                      throw new Error(
                      // eslint-disable-next-line quotes
                      "`tabRoute` Attribute can't be undefined in tab switcher.");
                  }
              });
          });
          /**
           * getting each @tabs
           */
          regTab.tabs.forEach(function (Tab) {
              if (Tab.tabRoute == regTab.initialTab) {
                  var tabComponent = document.getElementById(Tab.tabRoute);
                  if (tabComponent != null && tabComponent != undefined) {
                      if (regTab.activeTabClass != undefined &&
                          regTab.activeTabClass != null &&
                          regTab.activeTabClass != '') {
                          tabComponent.classList.add(regTab.activeTabClass);
                      }
                      else {
                          tabComponent.style.setProperty('display', 'block', 'important');
                          tabComponent.classList.add('rm-tab-active');
                      }
                  }
                  else {
                      throw new Error(
                      // eslint-disable-next-line quotes
                      '`' + Tab.tabRoute + "` tabRoute container can't be undefined.");
                  }
              }
              var Route = {
                  method: 'GET',
                  meta_loader: false,
                  content_url: Tab.content_url,
                  component_type: RouteComponentTypes.TAB,
                  container: "#".concat(Tab.tabRoute),
                  preloader: Tab.preloader,
                  error_content: Tab.error_content,
                  data: {},
                  http_url_change: false,
                  http_url: '',
              };
              if (Tab.data != undefined || Tab.data != null) {
                  Route.data = Tab.data;
              }
              /**
               * @rendering Tab content on first load
               */
              route(Route);
          });
      });
  };

  /* eslint-disable @typescript-eslint/no-explicit-any */
  /**
   * @namespace localState is to handles all local states.
   */
  exports.localState = void 0;
  (function (localState) {
      var InitDefaultState = function (selectors, value) {
          if (selectors === void 0) { selectors = null; }
          if (value === void 0) { value = undefined; }
          if (selectors != null) {
              if (Array.isArray(selectors)) {
                  selectors.forEach(function (selector) {
                      __render_state_value(selector, value);
                  });
              }
              else {
                  __render_state_value(selectors, value);
              }
          }
      };
      /**
       * @useState is to handle locally reactive and non-reactive state.
       * useState(@param defaultValue, @param selector);
       * @param selector should be className | idName | null.
       * @param defaultValue can be anything.
       * when @param selector is not null, state is reactive at that time, it's mean on state change, value will update automatic.
       */
      localState.useState = function (defaultValue, selectors) {
          if (defaultValue === void 0) { defaultValue = undefined; }
          if (selectors === void 0) { selectors = null; }
          var value = defaultValue;
          InitDefaultState(selectors, value);
          var getValue = function () { return value; };
          var setValue = function (newValue) {
              value = newValue;
              InitDefaultState(selectors, value);
          };
          return [getValue, setValue];
      };
  })(exports.localState || (exports.localState = {}));

  var registerOnDemandTabView = function (OnDemandTabViews) {
      if (OnDemandTabViews == undefined || OnDemandTabViews == null) {
          throw new Error("OnDemandTabViews is not defined, You must need to register OnDemandTabViews to call registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
      }
      if (!(OnDemandTabViews instanceof Array)) {
          throw new Error("OnDemandTabViews must be an array, You must need to register OnDemandTabViews as Array-Object in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
      }
      if (OnDemandTabViews.length < 1) {
          throw new Error("Can't register an empty array, You must need to register OnDemandTabViews as Array-Object in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
      }
      // validate the OnDemandTabViews
      for (var i = 0; i < OnDemandTabViews.length; i++) {
          if (OnDemandTabViews[i].TabViewId == undefined ||
              OnDemandTabViews[i].TabViewId == null) {
              throw new Error("TabViewId is not defined, You must need to register TabViewId in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
          }
          if (OnDemandTabViews[i].TabContentPath == undefined ||
              OnDemandTabViews[i].TabContentPath == null) {
              throw new Error("TabContentPath is not defined, You must need to register TabContentPath in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
          }
          if (OnDemandTabViews[i].HttpUrlChange == undefined ||
              OnDemandTabViews[i].HttpUrlChange == null) {
              throw new Error("HttpUrlChange is not defined, You must need to register HttpUrlChange in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
          }
          // validate the TabViewId is string or not
          if (typeof OnDemandTabViews[i].TabViewId !== 'string') {
              throw new Error("TabViewId must be a string, You must need to register TabViewId as string in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
          }
          // validate the TabViewId is empty or not
          if (OnDemandTabViews[i].TabViewId == '') {
              throw new Error("TabViewId is empty, You must need to register TabViewId in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
          }
          // validate the TabContentPath is string or not
          if (typeof OnDemandTabViews[i].TabContentPath !== 'string') {
              throw new Error("TabContentPath must be a string, You must need to register TabContentPath as string in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
          }
          // validate the TabContentPath is empty or not
          if (OnDemandTabViews[i].TabContentPath == '') {
              throw new Error("TabContentPath is empty, You must need to register TabContentPath in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
          }
          // validate the HttpUrlChange is boolean or not
          if (typeof OnDemandTabViews[i].HttpUrlChange !== 'boolean') {
              throw new Error("HttpUrlChange must be a boolean, You must need to register HttpUrlChange as boolean in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
          }
          // register the TabView
          OnDemandTabViewStorage.RegisteredOnDemandTabViews.push(OnDemandTabViews[i]);
      }
      var current_http_url = window.location.href;
      if (current_http_url.includes('#')) {
          var split_http_url = current_http_url.split('#');
          var TabViewId = split_http_url[split_http_url.length - 1];
          render(TabViewId);
      }
      else {
          render();
      }
      UrlStateChecker();
      return {
          loadTabView: loadTabView,
          reloadTabView: reloadTabView,
      };
  };
  var render = function (TabViewId, HttpUrlChange) {
      if (HttpUrlChange === void 0) { HttpUrlChange = true; }
      if (OnDemandTabViewStorage.RegisteredOnDemandTabViews.length > 0) {
          // render first tabview
          var TabView = OnDemandTabViewStorage.RegisteredOnDemandTabViews[0];
          if (TabViewId != undefined && TabViewId != null && TabViewId != '') {
              // get tabview
              TabView = findRegisteredTabView(TabViewId);
              if (TabView == null) {
                  throw new Error("Can't render TabView, TabView '".concat(TabViewId, "' is not registered. You must need to register TabViewId in registerOnDemandTabView(). Check documentation for more info: ").concat(exports.Info.documentation, "}"));
              }
          }
          if (HttpUrlChange) {
              HttpUrlChange = TabView.HttpUrlChange;
          }
          var http_url = buildHttpUrlWithTabViewId(TabView.TabViewId);
          var TabViewData = TabView.TabViewData || {};
          var Preloader = TabView.Preloader || '';
          var Error_content = TabView.Error_content || '';
          var Route = {
              method: 'GET',
              meta_loader: false,
              content_url: TabView.TabContentPath,
              component_type: RouteComponentTypes.ON_DEMAND_TABVIEW,
              data: TabViewData,
              preloader: Preloader,
              error_content: Error_content,
              http_url_change: false,
              http_url: http_url,
          };
          route(Route);
          // change browser url
          if (HttpUrlChange) {
              var TabViewIndex = findRegisteredTabViewIndex(TabView.TabViewId);
              if (TabViewIndex == undefined) {
                  throw new Error("Can't replace browser url, TabView '".concat(TabView.TabViewId, "' is not found in register. Something went wrong. Check documentation for more info: ").concat(exports.Info.documentation, "}"));
              }
              if (TabViewIndex == 0) {
                  // console.log('replaceState', http_url);
                  window.history.replaceState({}, '', http_url);
                  return;
              }
              // console.log('pushState index', TabViewIndex);
              window.history.pushState({}, '', http_url);
          }
      }
      else {
          throw new Error("Can't render OnDemand TabViews,No TabViews Found. You must need to register OnDemandTabViews as Array-Object in registerOnDemandTabView(). Check documentation for more info: ".concat(exports.Info.documentation, "}"));
      }
  };
  var buildHttpUrlWithTabViewId = function (TabViewId) {
      var hash_id = "#".concat(TabViewId);
      var http_url = window.location.href;
      var split_http_url = http_url.split('#');
      http_url = split_http_url[0] + hash_id;
      return http_url;
  };
  var renderFromLoadedTabView = function (TabViewContent, HttpUrlChange) {
      if (HttpUrlChange === void 0) { HttpUrlChange = true; }
      if (document.querySelector(HtmlSelector.OnDemandTabView)) {
          __render_DOM("".concat(HtmlSelector.OnDemandTabView), TabViewContent.TabViewContent);
      }
      if (!HttpUrlChange) {
          return;
      }
      var http_url = buildHttpUrlWithTabViewId(TabViewContent.TabViewId);
      var TabViewIndex = findRegisteredTabViewIndex(TabViewContent.TabViewId);
      if (TabViewIndex == undefined) {
          throw new Error("Can't replace browser url, TabView '".concat(TabViewContent.TabViewId, "' is not found in register. Something went wrong. Check documentation for more info: ").concat(exports.Info.documentation, "}"));
      }
      if (TabViewIndex == 0) {
          // console.log('replaceState', http_url);
          window.history.replaceState({}, '', http_url);
          return;
      }
      // console.log('pushState index', TabViewIndex);
      window.history.pushState({}, '', http_url);
  };
  var loadTabView = function (TabViewId, HttpUrlChange) {
      if (HttpUrlChange === void 0) { HttpUrlChange = true; }
      OnDemandTabViewStorage.states.RequestedTabViewid = TabViewId;
      var TabView = findRegisteredTabView(TabViewId);
      if (TabView == null) {
          throw new Error("Can't load TabView, TabView '".concat(TabViewId, "' is not registered. You must need to register TabViewId in registerOnDemandTabView(). Check documentation for more info: ").concat(exports.Info.documentation, "}"));
      }
      var TabViewContent = findRegisteredTabViewContent(TabViewId);
      // console.log('Registerd tabview id', OnDemandTabViewStorage.states.RequestedTabViewid);
      // console.log('TabViewContent', TabViewContent);
      if (TabViewContent == null) {
          render(TabViewId, HttpUrlChange);
          return;
      }
      else {
          // console.log("called 2");
          renderFromLoadedTabView(TabViewContent, HttpUrlChange);
      }
  };
  var reloadTabView = function (TabViewId) {
      OnDemandTabViewStorage.states.RequestedTabViewid = TabViewId;
      var TabView = findRegisteredTabView(TabViewId);
      if (TabView == null) {
          throw new Error("Can't load TabView, TabView '".concat(TabViewId, "' is not registered. You must need to register TabViewId in registerOnDemandTabView(). Check documentation for more info: ").concat(exports.Info.documentation, "}"));
      }
      render(TabViewId, false);
  };
  var findRegisteredTabView = function (TabViewId) {
      var TabView = null;
      for (var i = 0; i < OnDemandTabViewStorage.RegisteredOnDemandTabViews.length; i++) {
          if (OnDemandTabViewStorage.RegisteredOnDemandTabViews[i].TabViewId ==
              TabViewId) {
              TabView = OnDemandTabViewStorage.RegisteredOnDemandTabViews[i];
              break;
          }
      }
      return TabView;
  };
  // find registered tabview by tabviewId and get the index number
  var findRegisteredTabViewIndex = function (TabViewId) {
      var TabViewIndex = undefined;
      for (var i = 0; i < OnDemandTabViewStorage.RegisteredOnDemandTabViews.length; i++) {
          if (OnDemandTabViewStorage.RegisteredOnDemandTabViews[i].TabViewId ==
              TabViewId) {
              TabViewIndex = i;
              break;
          }
      }
      return TabViewIndex;
  };
  var findRegisteredTabViewContent = function (TabViewId) {
      var RegisterdTabViewContent = null;
      for (var i = 0; i < OnDemandTabViewStorage.RegisterdTabViewsContents.length; i++) {
          if (OnDemandTabViewStorage.RegisterdTabViewsContents[i].TabViewId == TabViewId) {
              RegisterdTabViewContent =
                  OnDemandTabViewStorage.RegisterdTabViewsContents[i];
              break;
          }
      }
      return RegisterdTabViewContent;
  };
  var UrlStateChecker = function () {
      window.onpopstate = function (e) {
          var current_http_url = window.location.href;
          if (current_http_url.includes('#')) {
              var split_http_url = current_http_url.split('#');
              var TabViewId = split_http_url[split_http_url.length - 1];
              // console.log('TabViewId', TabViewId);
              loadTabView(TabViewId, false);
          }
      };
  };

  exports.await_rendering = await_rendering;
  exports.initTabs = initTabs;
  exports.navigate = navigate;
  exports.pop_route = pop_route;
  exports.push_route = push_route;
  exports.registerMetaUrl = registerMetaUrl;
  exports.registerOnDemandTabView = registerOnDemandTabView;
  exports.registerServerHost = registerServerHost;
  exports.register_http_routes = register_http_routes;
  exports.register_routes_footers = register_routes_footers;
  exports.register_routes_headers = register_routes_headers;
  exports.render = render$1;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
